/*
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace BindingSimpleCS
{

	// La classe Article
	internal class Article : object
		 {
		  private string fdsignation = "";
		  private double fprix = 0.0;
		  private int fstock = 0;
		  public string Dsignation
			{ get { return fdsignation; }
			  set { fdsignation = value; }
			}
		  public double Prix
			{ get { return fprix; }
			  set { fprix = value; }
			}
		  public int Stock
			{ get {return fstock; }
			  set { fstock = value; }
			}
		  public Article(string vDsignation, double vPrix, int vStock)
		  {
		   Dsignation = vDsignation;
		   Prix = vPrix;
		   Stock = vStock;
		  }
		 }


	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.GroupBox gb1;
		private System.Windows.Forms.TextBox tbDesignation;
		private System.Windows.Forms.TextBox tbPrix;
		private System.Windows.Forms.TextBox tbStock;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label lposition;
		private System.Windows.Forms.Button btnPremier;
		private System.Windows.Forms.Button btnPrcdent;
		private System.Windows.Forms.Button btnSuivant;
		private System.Windows.Forms.Button btnDernier;

		private Article[] Liste = new Article[3];

		public WinForm()
		{
			InitializeComponent();
			// init de la liste
			Liste[0] = new Article("Gomme",1.55,15);
			Liste[1] = new Article("Feutre noir",1.85,80);
			Liste[2] = new Article("Double dcimtre",1.15,35);
			// liaison des contrles  la liste (databinding)
			tbDesignation.DataBindings.Add("Text", Liste, "Dsignation");
			tbPrix.DataBindings.Add("Text",Liste,"Prix");
			tbStock.DataBindings.Add("Text",Liste,"Stock");
			UpdatePosLabel();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gb1 = new System.Windows.Forms.GroupBox();
			this.btnDernier = new System.Windows.Forms.Button();
			this.btnSuivant = new System.Windows.Forms.Button();
			this.btnPrcdent = new System.Windows.Forms.Button();
			this.btnPremier = new System.Windows.Forms.Button();
			this.lposition = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.tbStock = new System.Windows.Forms.TextBox();
			this.tbPrix = new System.Windows.Forms.TextBox();
			this.tbDesignation = new System.Windows.Forms.TextBox();
			this.gb1.SuspendLayout();
			this.SuspendLayout();
			// 
			// gb1
			// 
			this.gb1.Controls.Add(this.btnDernier);
			this.gb1.Controls.Add(this.btnSuivant);
			this.gb1.Controls.Add(this.btnPrcdent);
			this.gb1.Controls.Add(this.btnPremier);
			this.gb1.Controls.Add(this.lposition);
			this.gb1.Controls.Add(this.label4);
			this.gb1.Controls.Add(this.label3);
			this.gb1.Controls.Add(this.label2);
			this.gb1.Controls.Add(this.label1);
			this.gb1.Controls.Add(this.tbStock);
			this.gb1.Controls.Add(this.tbPrix);
			this.gb1.Controls.Add(this.tbDesignation);
			this.gb1.Location = new System.Drawing.Point(8, 16);
			this.gb1.Name = "gb1";
			this.gb1.Size = new System.Drawing.Size(416, 232);
			this.gb1.TabIndex = 0;
			this.gb1.TabStop = false;
			this.gb1.Text = "Articles";
			// 
			// btnDernier
			// 
			this.btnDernier.Location = new System.Drawing.Point(328, 200);
			this.btnDernier.Name = "btnDernier";
			this.btnDernier.TabIndex = 11;
			this.btnDernier.Text = "Dernier >>";
			this.btnDernier.Click += new System.EventHandler(this.btnDernier_Click);
			// 
			// btnSuivant
			// 
			this.btnSuivant.Location = new System.Drawing.Point(224, 200);
			this.btnSuivant.Name = "btnSuivant";
			this.btnSuivant.TabIndex = 10;
			this.btnSuivant.Text = "Suivant >";
			this.btnSuivant.Click += new System.EventHandler(this.btnSuivant_Click);
			// 
			// btnPrcdent
			// 
			this.btnPrcdent.Location = new System.Drawing.Point(120, 200);
			this.btnPrcdent.Name = "btnPrcdent";
			this.btnPrcdent.TabIndex = 9;
			this.btnPrcdent.Text = "< Prcdent";
			this.btnPrcdent.Click += new System.EventHandler(this.btnPrcdent_Click);
			// 
			// btnPremier
			// 
			this.btnPremier.Location = new System.Drawing.Point(16, 200);
			this.btnPremier.Name = "btnPremier";
			this.btnPremier.TabIndex = 8;
			this.btnPremier.Text = "<< Premier";
			this.btnPremier.Click += new System.EventHandler(this.btnPremier_Click);
			// 
			// lposition
			// 
			this.lposition.Location = new System.Drawing.Point(120, 160);
			this.lposition.Name = "lposition";
			this.lposition.TabIndex = 7;
			this.lposition.Text = "---";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 160);
			this.label4.Name = "label4";
			this.label4.TabIndex = 6;
			this.label4.Text = "(position)";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 112);
			this.label3.Name = "label3";
			this.label3.TabIndex = 5;
			this.label3.Text = "Stock";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 72);
			this.label2.Name = "label2";
			this.label2.TabIndex = 4;
			this.label2.Text = "Prix";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.TabIndex = 3;
			this.label1.Text = "Dsignation";
			// 
			// tbStock
			// 
			this.tbStock.Location = new System.Drawing.Point(120, 112);
			this.tbStock.Name = "tbStock";
			this.tbStock.Size = new System.Drawing.Size(120, 20);
			this.tbStock.TabIndex = 2;
			this.tbStock.Text = "textBox3";
			// 
			// tbPrix
			// 
			this.tbPrix.Location = new System.Drawing.Point(120, 72);
			this.tbPrix.Name = "tbPrix";
			this.tbPrix.Size = new System.Drawing.Size(120, 20);
			this.tbPrix.TabIndex = 1;
			this.tbPrix.Text = "textBox2";
			// 
			// tbDesignation
			// 
			this.tbDesignation.Location = new System.Drawing.Point(120, 32);
			this.tbDesignation.Name = "tbDesignation";
			this.tbDesignation.Size = new System.Drawing.Size(248, 20);
			this.tbDesignation.TabIndex = 0;
			this.tbDesignation.Text = "textBox1";
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(432, 262);
			this.Controls.Add(this.gb1);
			this.Name = "WinForm";
			this.Text = "[Livre BDS] Binding objet - CSharp";
			this.gb1.ResumeLayout(false);
			this.ResumeLayout(false);
		}
#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new WinForm());
		}

		private void UpdatePosLabel()
		{
		 lposition.Text = (gb1.BindingContext[Liste].Position+1).ToString()+" / 3";
		}
		private void btnPremier_Click(object sender, System.EventArgs e)
		{
		 gb1.BindingContext[Liste].Position = 0;
		 UpdatePosLabel();
		}

		private void btnPrcdent_Click(object sender, System.EventArgs e)
		{
		 if (gb1.BindingContext[Liste].Position>0)
		  { gb1.BindingContext[Liste].Position -= 1;
			UpdatePosLabel();
		  }
		}

		private void btnSuivant_Click(object sender, System.EventArgs e)
		{
		if (gb1.BindingContext[Liste].Position<2)
		  { gb1.BindingContext[Liste].Position += 1;
			UpdatePosLabel();
		  }
		}

		private void btnDernier_Click(object sender, System.EventArgs e)
		{
		 gb1.BindingContext[Liste].Position =
		  gb1.BindingContext[Liste].Count-1;
		 UpdatePosLabel(); 
		}
	}
}
