{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}
unit MainForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data;

type
 TArticle = Class
   Private
    FDesignation : string;    // dsignation de l'article
    FPrix        : Currency;  // Prix de l'article
    FStock       : integer;   // pices en stock
   public
    property Designation : string   read FDesignation write FDesignation;
    property Prix        : Currency read FPrix        write FPrix;
    property Stock       : integer  read FStock       write FStock;
 end;

  TMainForm = class(System.Windows.Forms.Form)
  {$REGION 'Code manag du concepteur'}
  strict private
    /// <summary>
    /// Variable concepteur obligatoire.
    /// </summary>
    Components: System.ComponentModel.Container;
    gb1: System.Windows.Forms.GroupBox;
    tbDesignation: System.Windows.Forms.TextBox;
    tbPrix: System.Windows.Forms.TextBox;
    tbStock: System.Windows.Forms.TextBox;
    Button1: System.Windows.Forms.Button;
    Button2: System.Windows.Forms.Button;
    Button3: System.Windows.Forms.Button;
    Button4: System.Windows.Forms.Button;
    Label1: System.Windows.Forms.Label;
    Label2: System.Windows.Forms.Label;
    Label3: System.Windows.Forms.Label;
    Label4: System.Windows.Forms.Label;
    Label5: System.Windows.Forms.Label;
    /// <summary>
    /// Mthode obligatoire pour la gestion du concepteur - Ne modifiez pas
    /// le contenu de cette mthode avec l'diteur de code.
    /// </summary>
    procedure InitializeComponent;
    procedure Button1_Click(sender: System.Object; e: System.EventArgs);
    procedure Button2_Click(sender: System.Object; e: System.EventArgs);
    procedure Button3_Click(sender: System.Object; e: System.EventArgs);
    procedure Button4_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Nettoyage des ressources utilises.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Dclarations prives }
    FArticles : Array of TArticle;
    Procedure UpdatePositionLabel;
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TMainForm))]

implementation

{$AUTOBOX ON}


{$REGION 'Code gnr par le concepteur de Windows Form'}
/// <summary>
/// Mthode obligatoire pour la gestion du concepteur - Ne modifiez pas
/// le contenu de cette mthode avec l'diteur de code.
/// </summary>
procedure TMainForm.InitializeComponent;
begin
  Self.gb1 := System.Windows.Forms.GroupBox.Create;
  Self.Label5 := System.Windows.Forms.Label.Create;
  Self.Label4 := System.Windows.Forms.Label.Create;
  Self.Label3 := System.Windows.Forms.Label.Create;
  Self.Label2 := System.Windows.Forms.Label.Create;
  Self.Label1 := System.Windows.Forms.Label.Create;
  Self.Button4 := System.Windows.Forms.Button.Create;
  Self.Button3 := System.Windows.Forms.Button.Create;
  Self.Button2 := System.Windows.Forms.Button.Create;
  Self.Button1 := System.Windows.Forms.Button.Create;
  Self.tbStock := System.Windows.Forms.TextBox.Create;
  Self.tbPrix := System.Windows.Forms.TextBox.Create;
  Self.tbDesignation := System.Windows.Forms.TextBox.Create;
  Self.gb1.SuspendLayout;
  Self.SuspendLayout;
  // 
  // gb1
  // 
  Self.gb1.Controls.Add(Self.Label5);
  Self.gb1.Controls.Add(Self.Label4);
  Self.gb1.Controls.Add(Self.Label3);
  Self.gb1.Controls.Add(Self.Label2);
  Self.gb1.Controls.Add(Self.Label1);
  Self.gb1.Controls.Add(Self.Button4);
  Self.gb1.Controls.Add(Self.Button3);
  Self.gb1.Controls.Add(Self.Button2);
  Self.gb1.Controls.Add(Self.Button1);
  Self.gb1.Controls.Add(Self.tbStock);
  Self.gb1.Controls.Add(Self.tbPrix);
  Self.gb1.Controls.Add(Self.tbDesignation);
  Self.gb1.Location := System.Drawing.Point.Create(11, 9);
  Self.gb1.Name := 'gb1';
  Self.gb1.Size := System.Drawing.Size.Create(398, 198);
  Self.gb1.TabIndex := 0;
  Self.gb1.TabStop := False;
  Self.gb1.Text := 'Articles';
  // 
  // Label5
  // 
  Self.Label5.ForeColor := System.Drawing.SystemColors.HotTrack;
  Self.Label5.Location := System.Drawing.Point.Create(23, 114);
  Self.Label5.Name := 'Label5';
  Self.Label5.TabIndex := 11;
  Self.Label5.Text := '(position)';
  // 
  // Label4
  // 
  Self.Label4.Location := System.Drawing.Point.Create(23, 87);
  Self.Label4.Name := 'Label4';
  Self.Label4.TabIndex := 10;
  Self.Label4.Text := 'Stock';
  // 
  // Label3
  // 
  Self.Label3.Location := System.Drawing.Point.Create(23, 58);
  Self.Label3.Name := 'Label3';
  Self.Label3.TabIndex := 9;
  Self.Label3.Text := 'Prix';
  // 
  // Label2
  // 
  Self.Label2.Location := System.Drawing.Point.Create(23, 27);
  Self.Label2.Name := 'Label2';
  Self.Label2.TabIndex := 8;
  Self.Label2.Text := 'Dsignation';
  // 
  // Label1
  // 
  Self.Label1.ForeColor := System.Drawing.Color.DarkBlue;
  Self.Label1.Location := System.Drawing.Point.Create(129, 114);
  Self.Label1.Name := 'Label1';
  Self.Label1.TabIndex := 7;
  Self.Label1.Text := 'Label1';
  // 
  // Button4
  // 
  Self.Button4.Location := System.Drawing.Point.Create(308, 165);
  Self.Button4.Name := 'Button4';
  Self.Button4.TabIndex := 6;
  Self.Button4.Text := 'Dernier >>';
  Include(Self.Button4.Click, Self.Button4_Click);
  // 
  // Button3
  // 
  Self.Button3.Location := System.Drawing.Point.Create(20, 165);
  Self.Button3.Name := 'Button3';
  Self.Button3.TabIndex := 5;
  Self.Button3.Text := '<< Premier';
  Include(Self.Button3.Click, Self.Button3_Click);
  // 
  // Button2
  // 
  Self.Button2.Location := System.Drawing.Point.Create(116, 165);
  Self.Button2.Name := 'Button2';
  Self.Button2.TabIndex := 4;
  Self.Button2.Text := '< Prcdent';
  Include(Self.Button2.Click, Self.Button2_Click);
  // 
  // Button1
  // 
  Self.Button1.Location := System.Drawing.Point.Create(212, 165);
  Self.Button1.Name := 'Button1';
  Self.Button1.TabIndex := 3;
  Self.Button1.Text := 'Suivant >';
  Include(Self.Button1.Click, Self.Button1_Click);
  // 
  // tbStock
  // 
  Self.tbStock.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.tbStock.Location := System.Drawing.Point.Create(129, 83);
  Self.tbStock.Name := 'tbStock';
  Self.tbStock.TabIndex := 2;
  Self.tbStock.Text := 'TextBox3';
  // 
  // tbPrix
  // 
  Self.tbPrix.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.tbPrix.Location := System.Drawing.Point.Create(129, 54);
  Self.tbPrix.Name := 'tbPrix';
  Self.tbPrix.TabIndex := 1;
  Self.tbPrix.Text := 'TextBox2';
  // 
  // tbDesignation
  // 
  Self.tbDesignation.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.tbDesignation.Location := System.Drawing.Point.Create(129, 23);
  Self.tbDesignation.Name := 'tbDesignation';
  Self.tbDesignation.Size := System.Drawing.Size.Create(255, 20);
  Self.tbDesignation.TabIndex := 0;
  Self.tbDesignation.Text := 'TextBox1';
  // 
  // TMainForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(424, 224);
  Self.Controls.Add(Self.gb1);
  Self.Name := 'TMainForm';
  Self.Text := '[Livre BDS] Exemple de data binding purement objet';
  Self.gb1.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TMainForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TMainForm.Create;
 var A : TArticle;
begin
  inherited Create;
  //
  // Obligatoire pour la gestion du concepteur de Windows Form
  //
  InitializeComponent;
  //
  // TODO: Ajouter du code au constructeur aprs l'appel de InitializeComponent
  //
  SetLength(Farticles,3);
  A := TArticle.Create;
  with A do begin
   Designation:='Trousse';
   Prix       := 5.50;
   Stock      := 5;
   end;
  FArticles[0] :=A;
  A := TArticle.Create;
  with A do begin
   Designation:='Crayon';
   Prix       := 1.65;
   Stock      := 50;
   end;
  FArticles[1] := A;
  A := TArticle.Create;
  with A do begin
   Designation:='Effaceur';
   Prix       := 2.10;
   Stock      := 20;
   end;
  FArticles[2] := A;

  tbDesignation.DataBindings.Add('Text',FArticles,'Designation');
  tbPrix.DataBindings.Add('Text',FArticles,'Prix');
  tbStock.DataBindings.Add('Text',FArticles,'Stock');

  UpdatePositionLabel;
end;

procedure TMainForm.Button4_Click(sender: System.Object; e: System.EventArgs);
begin
  gb1.BindingContext[FArticles].Position :=
   gb1.BindingContext[FArticles].Count -1;
  UpdatePositionLabel;
end;

procedure TMainForm.Button3_Click(sender: System.Object; e: System.EventArgs);
begin
 gb1.BindingContext[FArticles].Position := 0;
 UpdatePositionLabel;
end;

procedure TMainForm.Button2_Click(sender: System.Object; e: System.EventArgs);
begin
 gb1.BindingContext[FArticles].Position :=
  gb1.BindingContext[FArticles].Position -1 ;
 UpdatePositionLabel;
end;

procedure TMainForm.Button1_Click(sender: System.Object; e: System.EventArgs);
begin
  gb1.BindingContext[FArticles].Position :=
   gb1.BindingContext[FArticles].Position + 1 ;
  UpdatePositionLabel;
end;

procedure TMainForm.UpdatePositionLabel;
begin
 Label1.Text := Integer(gb1.BindingContext[FArticles].Position+1).Tostring+ ' / '+
                gb1.BindingContext[FArticles].Count.ToString;
end;

end.
